public interface Pattern 
{
	byte[] GetPattern();
	byte[] GetPatchedPattern();
	string GetName();
}

public class Pattern1 : Pattern
{
/** Mizubaku and the title screen of Sonic Jam have this */

/**
Games that have this:
- Mizubaku
- the title of Sonic Jam (ingame areas have another pattern)
- Mega Man 8 
*/
	
	byte[] Pattern.GetPattern()
	{
		byte[] pattern1 =
		{
			0x2A, 0x22, // mov.l r2,@r10
			0x60, 0xE2, // mov.l @r14,r0
			0x60, 0x00, // mov.b @r0,r0
			0x91, 0x1A, // mov.w @(0x038,pc),r1 ; 0x0604CE80 (0x00E0)
			0x60, 0x0C, // extu.b r0,r0
			0x20, 0x29, // and r2,r0
			0x30, 0x10, // cmp/eq r1,r0
			0x8B, 0x07, // bf 0x0604CE62
			0x61, 0xE2, // mov.l @r14,r1
			0x60, 0x10, // mov.b @r1,r0
			0x60, 0x0C, // extu.b r0,r0
			0x91, 0x13, // mov.w @(0x02A,pc),r1 ; 0x0604CE82 (0x00E3)
			0x30, 0x10, // cmp/eq r1,r0
			0x8B, 0x01, // bf 0x0604CE62
			0xA0, 0x04, // bra 0x0604CE6A
			0xE4, 0x20, // mov #0x20,r4
			0x60, 0xE2, // mov.l @r14,r0
			0x60, 0x00, // mov.b @r0,r0 ; <-- PATCH THIS!
			0xC9, 0xF0, // and #0xF0,r0
			0x64, 0x03, // mov r0,r4
		};

		return pattern1;
	}
	
	 byte[] Pattern.GetPatchedPattern()
	{
		byte[] patched1 = ((Pattern)this).GetPattern();
		
		patched1[0x22] = 0xE0;
		patched1[0x23] = 0x02;
		
		return patched1;
	}
	
	 string Pattern.GetName()
	{
		return "Pattern 1";
	}
}

public class Pattern2 : Pattern
{

/**
Games where this pattern is found:
- Sonic R
- Sonic 3D
- Manx TT Superbike
- Bug TOO!
- Duke Nukem 3D
- Pandemonium
*/
	
	 byte[] Pattern.GetPattern()
	{
		byte[] pattern2 =
		{	
			0x20, 0x0B, // or r0,r0 
			0xD5, 0x17, // mov.l @(0x060,pc),r5
			0x25, 0x10, // mov.b r1,@r5
			0x61, 0xA2, // mov.l @r10,r1
			0x71, 0xFF, // add #0xFF,r1
			0xA0, 0x3B, // bra 0x00033B96
			0x2A, 0x12, // mov.l r1,@r10
			0x60, 0x10, // mov.b @r1,r0
			0x92, 0x1D, // mov.w @(0x03E,pc),r2 ; 0x00033B60 (0x00E0)
			0xC9, 0xF0, // and #0xF0,r0
			0x30, 0x20, // cmp/eq r2,r0
			0x8B, 0x08, // bf 0x00033B3C
			0x61, 0x10, // mov.b @r1,r1
			0x92, 0x19, // mov.w @(0x036,pc),r2 ; 0x00033B62 (0x00E3)
			0x61, 0x1C, // extu.b r1,r1
			0x31, 0x20, // cmp/eq r2,r1
			0x8F, 0x03, // bf/s 0x00033B3C
			0xE4, 0x20, // mov #0x20,r4
			0xD1, 0x10, // mov.l @(0x044,pc),r1 ; 0x00033B78 (0x060380FC) 
			0xA0, 0x05, // bra 0x00033B46
			0x00, 0x09, // nop
			0x61, 0x92, // mov.l @r9,r1
			0x60, 0x10, // mov.b @r1,r0 ; <---- PATCH THIS!
			0xC9, 0xF0, // and #0xF0,r0
			0xD1, 0x0D, // mov.l @(0x038,pc),r1 ; 0x00033B78 (0x060380FC) 
			0x64, 0x03, // mov r0,r4
			0x41, 0x0B, // jsr @r1
			0x00, 0x09, // nop
		};
		
		return pattern2;
	}
	
	
	 byte[] Pattern.GetPatchedPattern()
	{
		byte[] patched2 = ((Pattern)this).GetPattern();
		
		patched2[0x2C] = 0xE0;
		patched2[0x2D] = 0x02;
		
		return patched2;
	}
	
	 string Pattern.GetName()
	{
		return "Pattern 2";
	}
}


public class Pattern3 : Pattern
{
	/** BreakThru has this */
	
	 byte[] Pattern.GetPattern()
	{
		byte[] pattern3 = 
		{
			0x62, 0xE2, // mov.l @r14,r2
			0x63, 0x20, // mov.b @r2,r3 <-- PATCH THIS! (e3 02)
			0x92, 0x57, // mov.w @(0x0B2,pc),r2 ; 0x0001ECD2 (0x00E0)
			0x63, 0x3C, // extu.b r3,r3
			0x23, 0x89, // and r8,r3
			0x33, 0x20, // cmp/eq r2,r3
			0x8B, 0x11, // bf 0x0001EC4E	
			0x62, 0xE2, // mov.l @r14,r2
			0x63, 0x20, // mov.b @r2,r3
			0x92, 0x51, // mov.w @(0x0A6,pc),r2 ; 0x0001ECD4 (0x00E3)
			0x63, 0x3C, // extu.b r3,r3
			0x33, 0x20, // cmp/eq r2,r3
			0x8B, 0x06, // bf 0x0001EC44
			0xB7, 0xD6, // bsr 0x0001FBE6
			0xE4, 0x20, // mov #0x20,r4
			0xE2, 0x20, // mov #0x20,r2
			0xD3, 0x26, // mov.l @(0x09C,pc),r3 ; 0x0001ECD8 (0x06053F94) 	
			0x23, 0x20, // mov.b r2,@r3
			0xA0, 0x12, // bra 0x0001EC68
			0x00, 0x09, // nop
			0x64, 0xE2, // mov.l @r14,r4 <-- PATCH THIS! (e4 02) // 2A
			0xB7, 0xCE, // bsr 0x0001FBE6 // 2C
			0x64, 0x40, // mov.b @r4,r4 //2E
			0xA0, 0x0D, // bra 0x0001EC68 //30 
			0x00, 0x09, // nop //32
			0x64, 0xE2, // mov.l @r14,r4 //34
			0x64, 0x40, // mov.b @r4,r4 //36
			0x64, 0x4C, // extu.b r4,r4 //38
			0x24, 0x89, // and r8,r4 //3a
			0xB7, 0xC6, // bsr 0x0001FBE6 //3c
		};
		
		return pattern3;
	}
	
	 byte[] Pattern.GetPatchedPattern()
	{
		byte[] patched3 = ((Pattern)this).GetPattern();
		
		patched3[0x02] = 0xE3;
		patched3[0x03] = 0x02;
		
		patched3[0x28] = 0xE4;
		patched3[0x29] = 0x02;
		
		return patched3;
	}
	
	 string Pattern.GetName()
	{
		return "Pattern 3";
	}
};

public class Pattern4 : Pattern
{
/**
The game selection, in-game sections and "Sonic Worlds" in Sonic Jam
have this
*/
	
	 byte[] Pattern.GetPattern()
	{
		byte[] pattern4 =
		{
			0x75, 0x02,	// add #0x02,r5
			0x63, 0xE3,	// mov r14,r3
			0xD1, 0x26,	// mov.l @(0x09C,pc),r1 ; 0x000014A4 (0x060F4A7E) 
			0x62, 0xE3,	// mov r14,r2
			0xDB, 0x27,	// mov.l @(0x0A0,pc),r11 ; 0x000014AC (0x060F4B56) 
			0x33, 0x7C,	// add r7,r3
			0x1F, 0x39,	// mov.l r3,@(0x024,r15)
			0x42, 0x00,	// shll r2
			0xD3, 0x24,	// mov.l @(0x094,pc),r3 ; 0x000014A8 (0x060F4A72) 
			0x32, 0x1C,	// add r1,r2
			0x1F, 0x28,	// mov.l r2,@(0x020,r15)
			0x33, 0xEC,	// add r14,r3
			0x1F, 0x37,	// mov.l r3,@(0x01C,r15)
			0x84, 0xF8,	// mov.b @(0x008,r15), r0
			0x60, 0x0C,	// extu.b r0,r0
			0xA1, 0x44,	// bra 0x000016AE
			0x3B, 0x0C,	// add r0,r11
			0x60, 0x50,	// mov.b @r5,r0 ; <-- PATCH THIS!
			0x60, 0x0C,	// extu.b r0,r0
			0x88, 0x02,	// cmp/eq #0x02,r0
			0x89, 0x0C,	// bt 0x00001448
			0x88, 0x16,	// cmp/eq #0x16,r0
			0x89, 0x42,	// bt 0x000014B8
			0x91, 0x35,	// mov.w @(0x06E,pc),r1 ; 0x000014A0 (0x00F0)
			0x30, 0x10,	// cmp/eq r1,r0
			0x89, 0x04,	// bt 0x00001442
			0x91, 0x33,	// mov.w @(0x06A,pc),r1 ; 0x000014A2 (0x00FF)
			0x30, 0x10,	// cmp/eq r1,r0
			0x89, 0x01,	// bt 0x00001442
			0xA0, 0x91,	// bra 0x00001564
			0x00, 0x09,	// nop
			0xDD, 0x1B,	// mov.l @(0x070,pc),r13 ; 0x000014B0 (0x0000FFFF) 
			0xA0, 0x8F,	// bra 0x00001566
			0x75, 0x02,	// add #0x02,r5
			0x75, 0x02,	// add #0x02,r5
			0x62, 0x50,	// mov.b @r5,r2
			0x28, 0x20,	// mov.b r2,@r8
			0x75, 0x02,	// add #0x02,r5
			0x63, 0x50,	// mov.b @r5,r3
			0xE2, 0x0F,	// mov #0x0F,r2
			0x29, 0x30,	// mov.b r3,@r9
			0x75, 0x02,	// add #0x02,r5
			0x6D, 0x80,	// mov.b @r8,r13
			0x6D, 0xDC,	// extu.b r13,r13
			0x61, 0x90,	// mov.b @r9,r1
			0x22, 0xD9,	// and r13,r2
			0x42, 0x08,	// shll2 r2
			0x42, 0x08,	// shll2 r2
			0x63, 0xD3,	// mov r13,r3
			0x23, 0xC9,	// and r12,r3
			0x43, 0x21,	// shar r3
			0x43, 0x21,	// shar r3
			0x43, 0x21,	// shar r3
			0x43, 0x21,	// shar r3
			0x32, 0x3C,	// add r3,r2
			0x61, 0x1C,	// extu.b r1,r1
			0x2F, 0x12,	// mov.l r1,@r15
			0x21, 0xC9,	// and r12,r1
			0x60, 0xF2,	// mov.l @r15,r0
			0x41, 0x08,	// shll2 r1
			0x41, 0x08,	// shll2 r1
			0x32, 0x1C,	// add r1,r2
			0xC9, 0x08,	// and #0x08,r0
			0x40, 0x18,	// shll8 r0
			0x40, 0x00,	// shll r0
			0x32, 0x0C,	// add r0,r2
			0xDD, 0x0A,	// mov.l @(0x02C,pc),r13 ; 0x000014B4 (0x0000E000) 
			0x60, 0xB0,	// mov.b @r11,r0
			0x88, 0x06,	// cmp/eq #0x06,r0
			0x8D, 0x02,	// bt/s 0x00001496
			0x2D, 0x2B,	// or r2,r13
			0xE2, 0x03,	// mov #0x03,r2
			0x2B, 0x20,	// mov.b r2,@r11
			0x60, 0x6C,	// extu.b r6,r0
			0x30, 0xEC,	// add r14,r0
			0xE3, 0x03,	// mov #0x03,r3
			0xA0, 0x66,	// bra 0x0000156C
			0x07, 0x34,	// mov.b r3,@(r0,r7)
		};
		
		return pattern4;
	}

	 byte[] Pattern.GetPatchedPattern()
	{
		byte[] patched4 = ((Pattern)this).GetPattern();
		
		patched4[0x22] = 0xE0;
		patched4[0x23] = 0x02;
		
		return patched4;
	}
	
	 string Pattern.GetName()
	{
		return "Pattern 4";
	}	
}

public class Pattern5 : Pattern
{
/**
Astal (J) has this
*/	
	
	 byte[] Pattern.GetPattern()
	{
		byte[] pattern5 =
		{
			0x28, 0x12,	// mov.l r1,@r8
			0x60, 0xE2,	// mov.l @r14,r0
			0x60, 0x00,	// mov.b @r0,r0 ; <-- PATCH THIS! WITH mov.b #0x02, r0
			0x60, 0x0C,	// extu.b r0,r0
			0xC9, 0xF0,	// and #0xF0,r0
			0xB2, 0xE9,	// bsr 0x060E067C
			0x64, 0x0C,	// extu.b r0,r4
			0x60, 0xE2,	// mov.l @r14,r0
			0x60, 0x00,	// mov.b @r0,r0
			0x60, 0x0C,	// extu.b r0,r0
			0xC8, 0x0F,	// tst #0x0F,r0
			0x8B, 0x11,	// bf 0x060E00D8
		};
		
		return pattern5;
	}
	
	 byte[] Pattern.GetPatchedPattern()
	{
		byte[] patched5 = ((Pattern)this).GetPattern();
		
		patched5[0x04] = 0xE0;
		patched5[0x05] = 0x02;
		
		return patched5;
	}
	
	 string Pattern.GetName()
	{
		return "Pattern 5";
	}
}

public class Pattern6 : Pattern
{
/**
Astal (U) has this
*/	
	
	 byte[] Pattern.GetPattern()
	{
		byte[] pattern6 =
		{
			0xA0, 0x11, // bra 0x000302C0
			0x22, 0x40, // mov.b r4,@r2
			0x60, 0xE2, // mov.l @r14,r0
			0x60, 0x00, // mov.b @r0,r0 ; <-- PATCH THIS!
			0x60, 0x0C, // extu.b r0,r0
			0xC9, 0xF0, // and #0xF0,r0
			0x64, 0x0C, // extu.b r0,r4
			0xD3, 0x0E, // mov.l @(0x03C,pc),r3 ; 0x000302E4 (0x060F29F0) 
			0x63, 0x30, // mov.b @r3,r3
			0x63, 0x3C, // extu.b r3,r3
			0x73, 0x02, // add #0x02,r3
			0xD2, 0x0D, // mov.l @(0x038,pc),r2 ; 0x000302E8 (0x060F29F8) 
			0x62, 0x22, // mov.l @r2,r2
			0x03, 0x27, // mul.l r2,r3
			0x03, 0x1A, // sts macl,r3
			0xD1, 0x0C, // mov.l @(0x034,pc),r1 ; 0x000302EC (0x060F2A04) 
			0x61, 0x12, // mov.l @r1,r1
		};
		
		return pattern6;
	}
	
	 byte[] Pattern.GetPatchedPattern()
	{
		byte[] patched6 = ((Pattern)this).GetPattern();
		
		patched6[0x06] = 0xE0;
		patched6[0x07] = 0x02;
		
		return patched6;
	}
	
	 string Pattern.GetName()
	{
		return "Pattern 6";
	}
}

public class Pattern7 : Pattern
{
/**
Burning Rangers (E) has this
*/	
	
	 byte[] Pattern.GetPattern()
	{
		byte[] pattern7 =
		{
			0x3C, 0x0C, // add r0,r12
			0x60, 0x6C, // extu.b r6,r0
			0x30, 0xEC, // add r14,r0
			0x07, 0x44, // mov.b r4,@(r0,r7)
			0x60, 0x50, // mov.b @r5,r0
			0x60, 0x0C, // extu.b r0,r0 ; <-- PATCH THIS! and.b #0x1F,r0 (0xC9 0x1F)
			0x88, 0x02, // cmp/eq #0x02,r0
			0x89, 0x0C, // bt 0x06007402
			0x88, 0x16, // cmp/eq #0x16,r0
			0x89, 0x43, // bt 0x06007474
			0x91, 0x35, // mov.w @(0x06E,pc),r1 ; 0x0600745A (0x00F0)
			0x30, 0x10, // cmp/eq r1,r0
			0x89, 0x04, // bt 0x060073FC
			0x91, 0x33, // mov.w @(0x06A,pc),r1 ; 0x0600745C (0x00FF)
			0x30, 0x10, // cmp/eq r1,r0
			0x89, 0x01, // bt 0x060073FC
			0xA0, 0x92, // bra 0x06007520
		};
		
		return pattern7;
	}
	
	 byte[] Pattern.GetPatchedPattern()
	{
		byte[] patched7 = ((Pattern)this).GetPattern();
		
		patched7[0x0A] = 0xC9;
		patched7[0x0B] = 0x1F;
		
		return patched7;
	}
	
	 string Pattern.GetName()
	{
		return "Pattern 7";
	}
}
